#
#  Search for "crashme", immediately following the first regexp.
#
# File: BibLexis.py
#
# Copyright (c) 2006 by []
# Generator: ArchGenXML Version 1.4.1
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """unknown <unknown>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.BibLexis.config import *


from Products.CMFCore.utils import UniqueObject

    
##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

BibLexis_schema = BaseSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class BibLexis(UniqueObject, BaseContent):
    security = ClassSecurityInfo()
    __implements__ = (getattr(UniqueObject,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'BibLexis'

    meta_type = 'BibLexis'
    portal_type = 'BibLexis'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 0
    allow_discussion = False
    #content_icon = 'BibLexis.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "BibLexis"
    typeDescMsgId = 'description_edit_biblexis'
    #toolicon = 'BibLexis.gif'

    schema = BibLexis_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    # tool-constructors have no id argument, the id is fixed
    def __init__(self, id=None):
        BaseContent.__init__(self,'biblexis_tool')
        
        ##code-section constructor-footer #fill in your manual code here
        ##/code-section constructor-footer


    # Methods

    PARTICLES = ['on','von','the','a','or','and','in','for','of','by','to','at']
    
    security.declarePrivate('fixupper')
    def fixupper(self,text):
	l = text.strip().split()
	for pos in range(len(l)-1,-1,-1):
	    word = l[pos]
	    if pos > 0:
		if l[pos-1].endswith(':') or not word.lower() in self.PARTICLES:
		    word = word[0]+word[1:].lower()
		else:
		    word = word.lower()
	    else:
		if word.lower() in ['article:']:
		    l.pop(pos)
		    continue
		else:
		    word = word[0]+word[1:].lower()
	    for cpos in range(len(word)-1,-1,-1):
		c = word[cpos]
		if cpos > 0:
		    if word[cpos-1] in ['.','/','-']:
			word = word[:cpos]+c.upper()+word[cpos+1:]
	    l[pos] = word
	return ' '.join(l)
    
    security.declarePublic('parse')
    def parse(self,text):
        """
        
        """
	import sre as re
	fixupper = self.fixupper
	
	text = re.sub(r'(?m)^[	 ]*','',text)
	
	# Single line with a four-digit number
	Ryear = r'^.*([0-9]{4})[^\n]*\n'
	# Line with mixed numbers and letters
	Rcite = r'\n([-a-zA-Z0-9&\',. ]+)\n'
	# Line beginning with "Length:"
	Rlength = r'\n[^\n]*[Ll][Ee][Nn][Gg][Tt][Hh]:[^\n]+\n'
	# Anything
	Rany = r'.*?'
	# Anything at all
	Rbigany = r'.*'
	# White space
	Rws = r'[\r\n	 ]*'
	# Title stuff
	Rtitlechunk = r'[-A-Za-z0-9/:;*.,\?\!\"\'&() ]+'
	Rtitlechunknocolon = r'[-A-Za-z0-9/;*.,\?\!\"\'&() ]+'
	Rtitlechunkupper = r'[-A-Z0-9/:;*.,\?\!\"\'&() ]+'
	Rtitle = '\n(%s(?:\n{,1}%s)*)\n' % (Rtitlechunk,Rtitlechunk)	
	Rtitletwocolons = '^(?:%s:  *)*(%s:  *%s  *[Oo][Rr]:  *%s)$' % (
	    Rtitlechunk,
	    Rtitlechunknocolon,
	    Rtitlechunknocolon,
	    Rtitlechunknocolon)	
	Rtitleonecolon = '^(?:%s:  *)*(%s:  *%s)$' % (
	    Rtitlechunk,
	    Rtitlechunknocolon,
	    Rtitlechunknocolon)
	Rtitlenocolon = '^(?:%s:  *)*(%s)$' % (Rtitlechunk,Rtitlechunknocolon)
	Rtitleupper = '^%s$' % (Rtitlechunkupper)
	Rtitlemixed = '^(?:%s)  *(%s)$' % (Rtitlechunkupper,Rtitlechunk)
	# Name header
	Rauthors = r'\nNAME: *(?:[Bb][Yy]  *)*([^\n]*)\n'

	# Contains a numeral
	num = r'.*[0-9].*'

	# All of the above, with an author.  try this first.
	rex1 = re.compile(Ryear
	       + Rws
	       + Rcite
	       + Rws
	       + Rlength
	       + Rws
	       + Rtitle
	       + Rbigany
	       + Rauthors
	       + Rbigany+'$',re.S)

	# All of the above, with no author.  the what-the-heck alternative.
	rex2 = re.compile(Ryear 
	       + Rws 
	       + Rcite 
	       + Rws
	       + Rlength 
	       + Rws 
	       + Rtitle
	       + Rbigany+'$',re.S)


	r = rex1.match(text)
	
	if not r:
	    r = rex2.match(text)
	

	# If it matches, we have the citation
	if r:
	    data = {}
	    data['publication_url'] = ''
	    data['number'] = ''
	    data['publication_year'] = r.group(1)
	    cite = r.group(2).split()
	    data['volume'] = ''
	    data['pages'] = ''
	    if re.match(num,cite[0]):
		data['volume'] = cite[0]
		cite = cite[1:]
	    if re.match(num,cite[-1]):
		data['pages'] = cite[-1]
		cite = cite[:-1]
	    data['journal'] = ' '.join(cite)
	    title =  r.group(3).replace('\n',' ')
	    if re.match(Rtitletwocolons,title):
		title = re.match(Rtitletwocolons,title).group(1)
	    elif re.match(Rtitleonecolon,title):
		title = re.match(Rtitleonecolon,title).group(1)
	    elif re.match(Rtitlenocolon,title):
		# it might be possible to embed this in the regexp.
		# easier to read this way, though.
		title = re.match(Rtitlenocolon,title).group(1)
	    if re.match(Rtitleupper,title):
		title = fixupper(title)
	    else:
	    	r2 = re.match(Rtitlemixed,title)
	    	if r2:
	    	    title = r2.group(1)
	    data['title'] = title.strip(' *')
	    if len(r.groups()) < 4:
		authorstring = ''
	    else:
		authorstring = r.group(4)
	    
	    # a pretty-good name parser.  singletons will work, at least if they
	    # are at the start or the end.
	    #authors = 'Bono, George Smith, Jr., Tom Hanks, and Taki'
	    #print authors
	    authorstring = re.sub('[0-9*]','',authorstring)
	    authors = re.split(r'(?:,*  *(?:AND|And|and|&)  *|, *)',authorstring)
	    for pos in range(len(authors)-1,-1,-1):
		chunk = authors[pos]
		if len(chunk.strip().split()) < 2:
		    if len(authors)-1 > pos > 0:
			authors[pos-1] = '%s, %s' % (authors[pos-1],authors[pos])
			authors.pop(pos)
		
	    authorlist = []
	    for author in authors:
		res = re.match(r'(.*[^,])  *(.*)',author.strip('*+ '))
		map = {}
		if res:
		    map['firstnames'] = fixupper(res.group(1).strip('*'))
		    map['lastname'] = fixupper(res.group(2).strip('*'))
		    map['homepage'] = ''
		else:
		    map['lastname'] = fixupper(author.strip('*'))
		    map['firstnames'] = ''
		    map['homepage'] = ''
		authorlist.append(map)
	    
	    data['authors'] = authorlist
		
	else:
	    # If it didn't match, we're done for
	    data = None

	return data

registerType(BibLexis,PROJECTNAME)
# end of class BibLexis

##code-section module-footer #fill in your manual code here
##/code-section module-footer



